<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="from字段:" prop="from">
          <el-input v-model="formData.from" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="to字段:" prop="to">
          <el-input v-model="formData.to" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="amount字段:" prop="amount">
          <el-input v-model.number="formData.amount" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="action字段:" prop="action">
          <el-input v-model="formData.action" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="execer字段:" prop="execer">
          <el-input v-model="formData.execer" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="height字段:" prop="height">
          <el-input v-model.number="formData.height" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="txhash字段:" prop="txhash">
          <el-input v-model="formData.txhash" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="blocktime字段:" prop="blocktime">
          <el-input v-model.number="formData.blocktime" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'PoolActionTxs'
}
</script>

<script setup>
import {
  createPoolActionTxs,
  updatePoolActionTxs,
  findPoolActionTxs
} from '@/api/poolActionTxs'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            from: '',
            to: '',
            amount: 0,
            action: '',
            execer: '',
            height: 0,
            txhash: '',
            blocktime: 0,
        })
// 验证规则
const rule = reactive({
               from : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               to : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               action : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               execer : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               height : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               txhash : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               blocktime : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findPoolActionTxs({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.repoolActionTxs
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createPoolActionTxs(formData.value)
               break
             case 'update':
               res = await updatePoolActionTxs(formData.value)
               break
             default:
               res = await createPoolActionTxs(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
